/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * Copyright (c) 2001  HASEGAWA Masafumi
 */

#include <basic.h>
#include <bstdlib.h>
#include <bstdio.h>
#include <tcode.h>
#include <tctype.h>
#include <tstring.h>
#include <btron/btron.h>
#include <btron/libapp.h>

#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <dirent.h>

#define MAX_EMULATE 10		// ߥ졼Ȥκ

// ߥ졼Ѿ
typedef struct
{
  DIR dir;
  struct dirent dirent;
}
BVDIR;

static BVDIR s_bvdir[MAX_EMULATE] = {
  {{-1}}, {{-1}}, {{-1}}, {{-1}}, {{-1}},
  {{-1}}, {{-1}}, {{-1}}, {{-1}}, {{-1}}
};

extern WERR get_link (const char* pathname, LINK* link);

// ߥ졼Ⱦꤹ
static DIR* set_dir (W fd)
{
  int i;

  for (i = 0; i < MAX_EMULATE; ++i)
    {
      if (s_bvdir[i].dir.dd_fd == -1)
	{
	  s_bvdir[i].dir.dd_fd = fd;
	  s_bvdir[i].dir.dd_loc = F_TOPEND;
	  return &(s_bvdir[i].dir);
	}
    }

  return NULL;
}

// ߥ졼Ⱦ
static BVDIR* get_dir (DIR* dir)
{
  int i;

  for (i = 0; i < MAX_EMULATE; ++i)
    {
      if (s_bvdir[i].dir.dd_fd != -1 && &(s_bvdir[i].dir) == dir)
	{
	  return s_bvdir + i;
	}
    }

  return NULL;
}

DIR* opendir(const char* name)
{
  LINK link;
  W mode, fd, err;

  err = get_link(name, &link);
  if (err < 0)
    {
      return NULL;
    }
  
  mode = F_READ;
  fd = opn_fil (&link, mode, NULL);
  if (fd < 0)
    {
      return NULL;
    }

  return set_dir (fd);
}

int closedir(DIR* dir)
{
  BVDIR* bvdir;
  W err;

  bvdir = get_dir (dir);
  if (bvdir == NULL)
    {
      return -1;
    }

  err = cls_fil (bvdir->dir.dd_fd);
  if (err < 0)
    {
      return -1;
    }
  bvdir->dir.dd_fd = -1;

  return 0;
}

struct dirent* readdir(DIR* dir)
{
  BVDIR* bvdir;
  W err;
  LINK link;
  TC name[L_FNM + 1];

  bvdir = get_dir (dir);
  if (bvdir == NULL)
    {
      return NULL;
    }

  err = fnd_lnk (bvdir->dir.dd_fd, bvdir->dir.dd_loc, NULL, 0, NULL);
  if (err < 0)
    {
      return NULL;
    }
  bvdir->dir.dd_loc = F_NFWD;

  err = rea_rec(bvdir->dir.dd_fd, 0, (B*) &link, sizeof(link), NULL, NULL);
  if (err < 0)
    {
      return NULL;
    }

  err = fil_sts(&link, name, NULL, NULL);
  if (err < 0)
    {
      return NULL;
    }

  bvdir->dirent.d_namlen = tcstoeucs (bvdir->dirent.d_name, name);

  return &(bvdir->dirent);
}

