/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * Copyright (c) 2001  HASEGAWA Masafumi
 */

#ifndef __EBI_IMAGELINK_H
#define __EBI_IMAGELINK_H

#include "ebi_config.h"
#include "ebi_reference.h"

__EBI_BEGIN_NAMESPACE

class Subbook;

class ImageLink : public Reference
{
 public:
  typedef enum
    {
      TYPE_MONO,
      TYPE_GRAY,
      TYPE_COLOR,
      TYPE_JPEG,
    }
  ImageType;

  ImageLink (Subbook* subbook, ImageType type, int width = 0, int height = 0);
  virtual ~ImageLink ();

  virtual Page* execute () const;
  ImageType getType () const;
  int getWidth () const;
  int getHeight () const;

 private:
  ImageType m_type;
  int m_width;
  int m_height;
};

__EBI_END_NAMESPACE

#endif /* __EBI_IMAGELINK_H */
