/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * Copyright (c) 2001  HASEGAWA Masafumi
 */

#ifndef __EBI_PAGE_H
#define __EBI_PAGE_H

#include "ebi_config.h"
#include "ebi_line.h"

__EBI_BEGIN_NAMESPACE

class Subbook;
class Device;
class Reference;

class Page
{
 public:
  Page (Subbook* subbook = NULL, const EB_Position* pos = NULL);
  virtual ~Page ();

  Subbook* getSubbook () const;
  void setDevice (Device* device);
  virtual void clear () = 0;
  virtual void draw (W low, W high) = 0;
  virtual W updateLayout () = 0;
  virtual const Reference* getReference (const PNT& pnt) const = 0;

 protected:
  Subbook* m_subbook;
  EB_Position m_pos;
  Device* m_device;
};

__EBI_END_NAMESPACE

#endif /* __EBI_PAGE_H */
