/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * Copyright (c) 2001  HASEGAWA Masafumi
 */

#ifndef __EBI_SUBBOOK_H
#define __EBI_SUBBOOK_H

#include "ebi_config.h"
#include "ebi_string.h"

__EBI_BEGIN_NAMESPACE

class Book;

class Subbook
{
 public:
  Subbook (Book* book, EB_Subbook_Code subbook);
  virtual ~Subbook ();

  Book* getBook () const;
  EB_Subbook_Code getSubbook () const;
  const String& getTitle () const;
  bool haveCopyright () const;
  bool haveMenu () const;

 public:
  bool updateList (EB_Book * book);
  int getCount () const;
  EB_Subbook_Code getSubbook (int index) const;

 private:
  Book* m_book;
  EB_Subbook_Code m_subbook;
  String m_title;
  bool m_haveMenu;
  bool m_haveCopyright;
  
  int m_count;
};

typedef std::list<Subbook*> Subbooks;

__EBI_END_NAMESPACE

#endif /* __EBI_SUBBOOK_H */
