/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * Copyright (c) 2000-2002  HASEGAWA Masafumi
 */

#ifndef _EBWORD_H_
#define _EBWORD_H_

#define APP_NAME "ebword"
#define APP_VERSION "1.0.6"

#ifdef LINUX
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>

#define L_PATHNM 256
#define E_OK 0

typedef enum tagBOOL
{
  FALSE,
  TRUE,
}
BOOL;
#else
#include <basic.h>
#include <bstdlib.h>
#include <bstdio.h>
#include <bctype.h>
#include <bstring.h>
#include <tcode.h>
#include <tctype.h>
#include <tstring.h>
#include <errcode.h>
#include <btron/btron.h>
#include <btron/dp.h>
#include <btron/hmi.h>
#include <btron/vobj.h>
#include <btron/libapp.h>
#include <btron/cnvend.h>
#include <btron/process.h>
#endif

#include <eb/eb.h>
#include <eb/appendix.h>
#include <eb/text.h>
#include <eb/error.h>

#define ALL_SUBBOOK (-1)

// ¹ԥ⡼
typedef enum
{
  MODE_SEARCH,		// 
  MODE_COPYRIGHT,	// 
  MODE_TITLE,		// ȥ
}
ExecMode;

// ¹ԥѥ᡼
typedef struct
{
  ExecMode exec_mode;			// ¹ԥ⡼
  char book_path[L_PATHNM + 1];		// ҤΥѥ̾
  char appendix_path[L_PATHNM + 1];	// ϿǡΥѥ̾
  int subbook_index;			// ܤֹ(-1Ƥ)
  char word[EB_MAX_WORD_LENGTH + 1];	// ñ
  BOOL gaiji_code;			// ɤ
  BOOL heading_only;			// Ф
}
Params;

// 
typedef struct
{
  EB_Book book;					// 
  EB_Appendix appendix;				// Ͽǡ
  EB_Subbook_Code subbooks[EB_MAX_SUBBOOKS];	// 
  int subbook_count;				// ܤο
  EB_Hookset* hookset;				// եå
}
Book;

EB_Error_Code g_error;

// hookset.c
EB_Hookset* initialize_hookset (BOOL gaiji_code);
void terminate_hookset ();

// output.c
void output_error_message (const char* str);
BOOL output_search (Book* book, BOOL heading_only);
BOOL output_title (Book* book, int subbook_index);
BOOL output_copyright (Book* book);

// params.c
BOOL get_params (int argc, char *const *argv, Params* params);

#endif /* not _EBWORD_H_ */
